'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var colorForStatus = new Map([['awaiting', { color: '#BF360C' }], ['checking', { color: '#FF6F00' }], ['finished', { color: '#43A047' }], ['running', { color: '#1976D2' }]]);

var CompatCard = function (_Component) {
    _inherits(CompatCard, _Component);

    function CompatCard() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, CompatCard);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CompatCard.__proto__ || Object.getPrototypeOf(CompatCard)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            cardHovered: false,
            footerHovered: false
        }, _this.handleFooterHover = function () {
            _this.setState({ footerHovered: true });
        }, _this.handleFooterBlur = function () {
            _this.setState({ footerHovered: false });
        }, _this.handleCardHover = function () {
            _this.setState({ cardHovered: true });
        }, _this.handleCardBlur = function () {
            _this.setState({ cardHovered: false });
        }, _this.handleSelect = function () {
            var _this$props = _this.props,
                onSelect = _this$props.onSelect,
                id = _this$props.id;


            onSelect && onSelect(id);
        }, _this.handleFooterClick = function () {
            var _this$props2 = _this.props,
                onFooterButtonClick = _this$props2.onFooterButtonClick,
                id = _this$props2.id;


            onFooterButtonClick && onFooterButtonClick(id);
        }, _this.handleHeaderClick = function (event) {
            var _this$props3 = _this.props,
                onHeaderButtonClick = _this$props3.onHeaderButtonClick,
                id = _this$props3.id;


            onHeaderButtonClick && onHeaderButtonClick(id);

            event.stopPropagation();
        }, _this.renderHeader = function () {
            var _this$props4 = _this.props,
                title = _this$props4.title,
                subtitle = _this$props4.subtitle,
                headerText = _this$props4.headerText,
                headerButton = _this$props4.headerButton;

            var hasHeaderButton = Boolean(headerButton);

            return _react2.default.createElement(
                'div',
                { style: style.header },
                _react2.default.createElement(
                    'div',
                    { style: style.headerContent },
                    _react2.default.createElement(
                        'span',
                        { style: style.headerTitle },
                        title
                    ),
                    _react2.default.createElement(
                        'span',
                        { style: style.headerSubtitle },
                        subtitle
                    ),
                    _react2.default.createElement(
                        'span',
                        { style: style.headerText },
                        headerText
                    )
                ),
                hasHeaderButton && _react2.default.createElement(
                    'div',
                    {
                        className: 'card__header-button',
                        style: style.headerButton,
                        onClick: _this.handleHeaderClick
                    },
                    headerButton
                )
            );
        }, _this.renderContent = function () {
            var _this$props5 = _this.props,
                contentTitle = _this$props5.contentTitle,
                contentText = _this$props5.contentText,
                primaryText = _this$props5.primaryText,
                secondaryText = _this$props5.secondaryText;


            return _react2.default.createElement(
                'div',
                {
                    className: 'card__content-text',
                    style: style.cardContentText
                },
                _react2.default.createElement(
                    'span',
                    { style: style.contentTitle },
                    contentTitle
                ),
                _react2.default.createElement(
                    'span',
                    { style: style.contentText },
                    contentText
                ),
                _react2.default.createElement(
                    'span',
                    { style: style.contentPrimary },
                    primaryText
                ),
                _react2.default.createElement(
                    'span',
                    { style: style.contentSecondary },
                    secondaryText
                )
            );
        }, _this.renderFooter = function () {
            var _this$props6 = _this.props,
                onFooterButtonClick = _this$props6.onFooterButtonClick,
                footerButtonLabel = _this$props6.footerButtonLabel,
                footerIcon = _this$props6.footerIcon,
                footerStatus = _this$props6.footerStatus;
            var status = footerStatus.status,
                text = footerStatus.text;

            var _colorForStatus$get = colorForStatus.get(status),
                color = _colorForStatus$get.color;

            var hasStatusText = Boolean(footerStatus);
            var hasFooterButton = Boolean(onFooterButtonClick);

            if (!hasStatusText && !hasFooterButton) {
                return null;
            }

            return _react2.default.createElement(
                'div',
                {
                    className: 'card__footer',
                    style: _this.state.footerHovered ? _extends({}, style.footer, style.footerHover) : style.footer,
                    onMouseEnter: _this.handleFooterHover,
                    onMouseLeave: _this.handleFooterBlur,
                    onClick: _this.handleFooterClick
                },
                hasStatusText && _react2.default.createElement(
                    'div',
                    { style: _extends({}, style.footerStatus, { color: color }) },
                    Boolean(footerIcon) && _react2.default.createElement(
                        'span',
                        { style: style.footerStatusIcon },
                        footerIcon
                    ),
                    _react2.default.createElement(
                        'strong',
                        { style: style.footerStatusName },
                        text
                    )
                ),
                hasFooterButton && _react2.default.createElement(
                    'div',
                    { style: style.footerButton },
                    footerButtonLabel
                )
            );
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(CompatCard, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                image = _props.image,
                onSelect = _props.onSelect;


            var hasImage = Boolean(image);
            var canSelect = Boolean(onSelect);

            var boxShadow = this.state.cardHovered ? style.cardHover.boxShadow : style.card.boxShadow;
            var cursor = canSelect ? 'pointer' : 'default';

            var containerStyle = _extends({}, style.cardContainer, {
                cursor: cursor
            });

            return _react2.default.createElement(
                'div',
                {
                    style: _extends({}, style.card, { boxShadow: boxShadow }),
                    onMouseEnter: this.handleCardHover,
                    onMouseLeave: this.handleCardBlur
                },
                _react2.default.createElement(
                    'div',
                    {
                        className: 'card__container',
                        style: containerStyle,
                        onClick: this.handleSelect
                    },
                    hasImage && _react2.default.createElement('div', { style: _extends({}, style.image, {
                            backgroundImage: 'url(' + this.props.image + ')'
                        }) }),
                    _react2.default.createElement(
                        'div',
                        { style: style.cardContent },
                        this.renderHeader(),
                        this.renderContent()
                    )
                ),
                this.renderFooter()
            );
        }
    }]);

    return CompatCard;
}(_react.Component);

var truncateStyle = {
    whiteSpace: 'nowrap',
    overflow: 'hidden',
    textOverflow: 'ellipsis'
};

var truncateContainerStyle = {
    minWidth: 0,
    overflow: 'hidden'
};

var style = {
    card: {
        fontFamily: 'Roboto, sans-serif',
        height: 215,
        position: 'relative',
        boxShadow: '0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23)',
        backgroundColor: '#fff'
    },
    cardHover: {
        boxShadow: '0 14px 28px rgba(0, 0, 0, 0.25), 0 10px 10px rgba(0, 0, 0, 0.22)'
    },
    cardContainer: {
        display: 'flex',
        height: '164px'
    },
    cardContent: _extends({
        padding: '12px',
        flex: 1
    }, truncateContainerStyle),
    image: {
        height: 164,
        width: 184,
        backgroundSize: 'cover'
    },
    header: {
        display: 'flex'
    },
    headerContent: _extends({
        flex: 1
    }, truncateContainerStyle),
    headerTitle: _extends({
        display: 'block',
        color: '#263238',
        margin: 0,
        textTransform: 'uppercase',
        fontSize: '.9rem',
        fontWeight: 700
    }, truncateStyle),
    headerSubtitle: _extends({
        display: 'block',
        color: '#90A4AE',
        margin: 0,
        fontSize: '.8rem'
    }, truncateStyle),
    headerText: _extends({
        display: 'block',
        color: '#607D8B',
        padding: '3px 0 0',
        fontSize: '.9rem'
    }, truncateStyle),
    headerButton: {
        padding: '0 0 12px 12px'
    },
    cardContentText: {},
    contentTitle: _extends({
        display: 'block',
        padding: '5px 0'
    }, truncateStyle),
    contentText: _extends({
        display: 'block',
        color: '#607D8B',
        fontSize: '.9rem'
    }, truncateStyle),
    contentPrimary: _extends({
        display: 'block',
        padding: '6px 0 0',
        color: '#263238',
        fontSize: '.9rem'
    }, truncateStyle),
    contentSecondary: _extends({
        display: 'block',
        padding: '6px 16px 0 0',
        color: '#263238',
        fontSize: '.9rem'
    }, truncateStyle),
    footer: _extends({
        backgroundColor: '#E3E2E2',
        display: 'flex',
        height: 51
    }, truncateContainerStyle),
    footerHover: {
        cursor: 'pointer',
        backgroundColor: '#DBDBDB'
    },
    footerStatus: _extends({
        paddingRight: '12px',
        lineHeight: '12px',
        flex: 1,
        display: 'flex',
        alignItems: 'center'
    }, truncateStyle),
    footerStatusIcon: {
        lineHeight: '12px',
        padding: '0 12px'
    },
    footerStatusName: {
        lineHeight: '51px',
        textTransform: 'uppercase'
    },
    footerButton: {
        lineHeight: '51px',
        borderLeft: '1px solid #CCCBCB',
        padding: '0 12px',
        textTransform: 'uppercase',
        fontSize: '.9rem'
    }
};

CompatCard.propTypes = {
    id: _propTypes2.default.any.isRequired,
    title: _propTypes2.default.string.isRequired,
    image: _propTypes2.default.string,
    subtitle: _propTypes2.default.string,
    headerText: _propTypes2.default.string,
    contentTitle: _propTypes2.default.string,
    contentText: _propTypes2.default.string,
    primaryText: _propTypes2.default.string,
    secondaryText: _propTypes2.default.string,
    headerButton: _propTypes2.default.node,
    footerButtonLabel: _propTypes2.default.string,
    footerIcon: _propTypes2.default.node,
    footerStatus: _propTypes2.default.shape({
        status: _propTypes2.default.string,
        text: _propTypes2.default.string
    }),
    onSelect: _propTypes2.default.func,
    onFooterButtonClick: _propTypes2.default.func,
    onHeaderButtonClick: _propTypes2.default.func
};

exports.default = CompatCard;