import React from 'react';

import CompatCard from './components';


function App() {
    const handleClick = id => {
        console.log('handleClick', id);
    };

    const handleHeaderButtonClick = id => {
        console.log('handleHeaderButtonClick', id);
    };

    const renderIcon = () => {
        const spanStyle = {
            width: '1em',
            height: '1em',
            overflow: 'hidden',
            fontSize: '24px',
            userSelect: 'none',
            flexShrink: 0,
            color: 'rgb(191, 54, 12)'
        };

        const svgStyle = {
            fill: 'currentColor',
            width: '1em',
            height: '1em',
            display: 'inline-block',
            fontSize: '24px',
            transition: 'fill 200ms cubic-bezier(0.4, 0, 0.2, 1) 0ms',
            userSelect: 'none',
            flexShrink: 0,
            color: 'rgb(191, 54, 12)'
        };

        return (
            <span
                style={spanStyle}
            >
                <svg
                    className="MuiSvgIcon-root-290"
                    focusable="false"
                    viewBox="0 0 24 24"
                    style={svgStyle}
                >
                    <g>
                        <path
                            d="M22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM12.5 8H11v6l4.75 2.85.75-1.23-4-2.37V8zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z">
                        </path>
                    </g>
                </svg>
            </span>
        );
    };

    return (
        <div>
            <CompatCard
                id={1}
                title="LO5521/2017"
                subtitle="12/04/2017 - 18/05/2017"
                headerText="Aberto em 12/04/2017"
                contentTitle="Cotação de cadeiras e assentos"
                contentText="Cadeiras de escritório e assentos para área externa."
                footerStatus={{status: 'awaiting', text: 'Em cotação'}}
                footerIcon={renderIcon()}
                footerButtonLabel="Abrir"
                onFooterButtonClick={handleClick}
                onHeaderButtonClick={handleHeaderButtonClick}
                primaryText="0001567/2017"
                secondaryText="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla vitae molestie sapien, sed luctus magna. Aliquam sed sapien pellentesque, commodo leo ut, volutpat augue. Curabitur facilisis interdum urna quis tempus. Fusce fermentum, odio nec lacinia interdum, metus mi condimentum mauris, sit amet ullamcorper lectus leo a dui - Ciente T"
                onSelect={handleClick}
                headerButton="toto"
                image="https://img.tecnisa.com.br/arquivos/estagioobra/128/Imagem/obra_flex_osasco_tecnisa.jpg"
            />
        </div>
    );
}

export default App;
